=== examples/ex_2modulesPIC/Makefile ===
CC="gcc"
CFLAGS=
EXEC=

all: ex.c
	$(CC) ex.c fun.c $(CFLAGS) -fPIC -o ex
	@ $(EXEC) ./ex > out.txt
clean:
	rm -f ex ex.unstripped out.txt *.s *.lib *.exp *.o *.err
check:
	@ $(EXEC) ./ex >/tmp/res.txt
	@ diff out.txt /tmp/res.txt && echo TEST OK
